package ru.dbotthepony.kstarbound.defs.tile

import ru.dbotthepony.kstarbound.defs.image.ImageReference
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory

@JsonFactory
data class RenderParameters(
	val texture: ImageReference,
	val variants: Int = 0,
	val multiColored: Boolean = false,
	val occludesBelow: Boolean = false,
	val lightTransparent: Boolean = false,
	val zLevel: Int,
) {
	init {
		checkNotNull(texture.imagePath.value) { "Tile render parameters are stateless, but provided image is a pattern: ${texture.raw}" }
	}
}
